<!DOCTYPE html>
<html>
<head>
	<meta charset="UTF-8">
	<title> Lesson 4 :: Task 1 </title>

	<link rel="stylesheet" href="css/normalize.css" />
    <link rel="stylesheet" href="css/style.css" />
</head>
<body>
	<form id="ValidationForm" class="form">
		<input class="form__input" type="text" name="login" placeholder="Ваш логин" />
		<input class="form__input" type="password" name="password" placeholder="Ваш пароль" />
		<input class="form__input" type="password" name="password_confirm" placeholder="Повторите пароль" />
		<label for="agree">
			<span>Вы согласны с лицензионым соглашением.</span>
			<input type="checkbox" id="agree" />
		</label>
		<button class="form__button" type="submit" id="submit" disabled> Отправить </button>
	</form>

<script>
	/*
		Задание:

			Использую кастомную валидацию (Не используя Constraint Validation API) 
			сделать валидацию формы по следующим правилам:

			1. Логин / Пароль не может быть пустым
			2. Пароли должны совпадть
			3. Пока не стоит что юзер согласен с лиц. соглашением - кнопка отправки не активна

			Валидным полям нужно добавить класс valid, полям с ошибкой нужно добавить класс invalid
	*/

	function notEmpty (value) {
		if(value) {
			return true;
		}
		return false;
	}

	function isEqual(value1, value2) {
		return value1 === value2;
	}

	let button = document.getElementById("submit")
	button.addEventListener("click", eventHandler)
	let agree = document.getElementById("agree");
	agree.addEventListener("change", agreeHandler)
	
	let form = document.forms.ValidationForm;

	function agreeHandler(){
		button.disabled = !agree.checked
	}
	
	/**
	 * @param {Event} event
	 */	
	function eventHandler(event) {
		if(!isValid()) {
			event.preventDefault();
		}
	}

	function isValid() {
		let isValid = true;
		

		let login = form.querySelector('.form__input[name="login"]');
		let pass1 = form.querySelector('.form__input[name="password"]');
		let pass2 = form.querySelector('.form__input[name="password_confirm"]');
		
		if(notEmpty(login.value)) {
			login.classList.add("valid")
			login.classList.remove("invalid")
		} else {
			isValid = false;
			login.classList.add("invalid")
			login.classList.remove("valid")
		}

		if(notEmpty(pass1) && isEqual(pass1.value, pass2.value)) {
			pass1.classList.add("valid")
			pass1.classList.remove("invalid")
			pass2.classList.add("valid")
			pass2.classList.remove("invalid")
		} else {
			isValid = false;
			pass1.classList.add("invalid")
			pass1.classList.remove("valid")
			pass2.classList.add("invalid")
			pass2.classList.remove("valid")
		}

		if(agree.checked) {
			agree.classList.add("valid")
			agree.classList.remove("invalid")
		} else  {
			isValid = false;
			agree.classList.add("invalid")
			agree.classList.remove("valid")
		}

		return isValid;
	}
</script>
</body>
</html>
